var allTabs = {};

var setting = {
  maxTabs: 15,
  text: "Превышен лимит открытых вкладок!",
  action: 0
};

class Conrol {
  constructor () {
    this.colTab = 0; 
  }

  updateColTab () {
    chrome.tabs.query({}, (tabs) => {
      this.colTab = tabs.length;
      allTabs = tabs;
      for (var i = 0; i < tabs.length; i++) {
        break;
      }
      chrome.browserAction.setBadgeText({text: (setting.maxTabs - this.colTab)+"+"});
    });
    
    return true;
  }

  chackMaxTabs (up = false) {
    if(up)
      this.updateColTab();

    if(this.colTab  > setting.maxTabs) {
      if(up) {
        chrome.tabs.remove(allTabs[0].id);
        return true;
      }
      switch (setting.action) {
        case 0:
          alert(setting.text);
          chrome.tabs.remove(allTabs[0].id);
          return true;
        break
        case 1:
          return false;
        break;
      }
    }else {
      return true;
    }
  }

  createTab (tab) {
    conrol.colTab ++;
    var aa = this.chackMaxTabs();

    if (aa)
      return true;
    else {
      chrome.tabs.remove(tab.id, () => {
        conrol.colTab--;
        alert(setting.text);
      });
    }
  }
};

var conrol = new Conrol();

setInterval(update, 2000); // Обновление вкладок 2 минуты

function update () {
  conrol.updateColTab();
  conrol.chackMaxTabs(true);
}

function settingUpdate () {
  fetch('http://config/setchromelimittab.json', {
    headers: {
      'Content-type': 'application/json; charset=UTF-8'
    }
  })
  .then(res => res.json())
  .then(function (res) {
    if(typeof res == "object" && "maxTabs" in res)
      setting = res
  })
  .catch (error => {
    console.log(error)
  }) 
}

setInterval(settingUpdate, 5*60*1000); //Запрос к серверу 5 минут
settingUpdate();


chrome.tabs.onCreated.addListener (function (tab) {
  conrol.createTab(tab);
});
